<?php

////////////////////////////////////////////////////////////////
// Program:   BareNuked Content Management System for webpage //
//            development                                     //
// Author:    Jay R. Tomten (email: jay@remin8.com |          //
//            web: http://www.remin8.com)                     //
// Address:   204 Truman Street, Knob Noster, MO 65336        //
// Copyright: (C) 2005                                        //
//                                                            //
// This program is free software; you can redistribute it     //
// and/or modify it under the terms of the GNU General Public //
// License as published by the Free Software Foundation;      //
// either version 2 of the License, or (at your option) any   //
// later version.                                             //
////////////////////////////////////////////////////////////////

// admin check
require ("start.php");

// global
$thumbSize = $configuration[thumb];       // max size of thumbnails
$resizedSize = $configuration[resized];   // max size of resized image
$message = "";                            // user messages



////////////////////////////////////////////////////////////////
// function MakeThumb()
// Create thumbnail
////////////////////////////////////////////////////////////////
function MakeThumb($id){
  global $thumbSize, $message;
  $targetHeight;
  $targetWidth;
  
  // database ops
  $db = new DB();
  $db->query("SELECT image_file FROM " . DB_PREFIX . "_album_images WHERE id = '$id' ");
  $image = $db->next_record();
  $db->close();
  
  // get file info
  $filename = $image[image_file];
  list($imageWidth, $imageHeight, $type) = getimagesize("../gallery/main/$filename");

  // is the image big enough?
  if($imageWidth > $thumbSize || $imageHeight > $thumbSize) {
    
    // figure out new size
    if($imageWidth > $imageHeight) { // if landscape figure new height
      $ratio = ($imageHeight / $imageWidth);
      $targetWidth = $thumbSize;
      $targetHeight = round($thumbSize * $ratio);
    } else { // else portrait figure new width
      $ratio = ($imageWidth / $imageHeight);
      $targetHeight = $thumbSize;
      $targetWidth = round($thumbSize * $ratio);
    }
  
    //process image
    if ($type == "2") {
      $source = imagecreatefromjpeg("../gallery/main/$filename");
      $destination = imagecreatetruecolor($targetWidth, $targetHeight);
      imagecolorallocate($destination, 255, 255, 255);
      imagecopyresampled($destination, $source, 0, 0, 0, 0, $targetWidth, $targetHeight, imagesx($source), imagesy($source));
      imagejpeg($destination, "../gallery/thumb/$filename");
    } elseif ($type == "3") {
      $source = imagecreatefrompng("../gallery/main/$filename");
      $destination = imagecreatetruecolor($targetWidth, $targetHeight);
      imagecolorallocate($destination, 255, 255, 255);
      imagecopyresampled($destination, $source, 0, 0, 0, 0, $targetWidth, $targetHeight, imagesx($source), imagesy($source));
      imagepng($destination, "../gallery/thumb/$filename");
    }

  // if not big enough copy to thumb folder
  } else copy("../gallery/main/$filename", "../gallery/thumb/$filename");
  
  // change file permissions
  chmod("../gallery/thumb/$filename", 0755);
}



////////////////////////////////////////////////////////////////
// function MakeResized()
// Create resized image
////////////////////////////////////////////////////////////////
function MakeResized($id){
  global $resizedSize, $message;
  $targetHeight;
  $targetWidth;
  
  // database ops
  $db = new DB();
  $db->query("SELECT image_file FROM " . DB_PREFIX . "_album_images WHERE id = '$id' ");
  $image = $db->next_record();
  $db->close();
  
  // get file info
  $filename = $image[image_file];
  list($imageWidth, $imageHeight, $type) = getimagesize("../gallery/main/$filename");
  
  // is the image big enough?
  if($imageWidth > $resizedSize || $imageHeight > $resizedSize) {
  
    // figure out new size
    if($imageWidth > $imageHeight) { // if landscape figure new height
      $ratio = ($imageHeight / $imageWidth);
      $targetWidth = $resizedSize;
      $targetHeight = round($resizedSize * $ratio);
    } else { // else portrait figure new width
      $ratio = ($imageWidth / $imageHeight);
      $targetHeight = $resizedSize;
      $targetWidth = round($resizedSize * $ratio);
    }
    
    //process image
    if ($type == "2") {
      $source = imagecreatefromjpeg("../gallery/main/$filename");
      $destination = imagecreatetruecolor($targetWidth, $targetHeight);
      imagecolorallocate($destination, 255, 255, 255);
      imagecopyresampled($destination, $source, 0, 0, 0, 0, $targetWidth, $targetHeight, imagesx($source), imagesy($source));
      imagejpeg($destination, "../gallery/resized/$filename");
    } elseif ($type == "3") {
      $source = imagecreatefrompng("../gallery/main/$filename");
      $destination = imagecreatetruecolor($targetWidth, $targetHeight);
      imagecolorallocate($destination, 255, 255, 255);
      imagecopyresampled($destination, $source, 0, 0, 0, 0, $targetWidth, $targetHeight, imagesx($source), imagesy($source));
      imagepng($destination, "../gallery/resized/$filename");
    }
    
  // if not big enough copy to resized folder
  } else copy("../gallery/main/$filename", "../gallery/resized/$filename");
  
  // change file permissions
  chmod("../gallery/resized/$filename", 0777);
}



////////////////////////////////////////////////////////////////
// DeleteImage()
// deletes an images files and database entries
////////////////////////////////////////////////////////////////
function DeleteImage($deleteId){
  global $message;
  
  // database ops
  $db = new DB();
  $db->query("SELECT * FROM ".DB_PREFIX."_album_images WHERE id='$deleteId'");
  $image = $db->next_record();
  $filename = $image[image_file];
  
  // check that all images are deleted then delete db entry
  if (unlink("../gallery/main/$filename") && unlink("../gallery/thumb/$filename") && unlink("../gallery/resized/$filename")) {
    $db->query("DELETE FROM ".DB_PREFIX."_album_images WHERE id = '$deleteId'");
    $message .= "Database entry and all images deleted.<br />";
  } else $message .= "Error removing $filename!<br />";
  $db->close();
}



////////////////////////////////////////////////////////////////
// function UploadImage()
// uploads and processes images into file structure and database
////////////////////////////////////////////////////////////////
function UploadImage(){
  global $_FILES;
  global $message;
  $uploadNeed = $_POST[uploadNeed];
  $albumId = $_POST[albumId];
  
  // processes all images: ammount from uploadNeed (form)
  for($x=0;$x<$uploadNeed;$x++){
    $db = new DB();
    $filename = $_FILES['userfile' . $x]['name'];
    if(preg_match("/.jpg$|.jpeg$/i",$_FILES['userfile' . $x]['name'])) {
      if(is_uploaded_file($_FILES['userfile' . $x]['tmp_name'])) {
        $db->query("INSERT INTO " . DB_PREFIX . "_album_images (album_id, image_file) VALUES ('$albumId', '$filename')");
        $db->query("SELECT id FROM " . DB_PREFIX . "_album_images WHERE image_file = '$filename' ");
        $image = $db->next_record();
        $new_filename = $image[id] . "_" . $filename;
        $db->query("UPDATE " . DB_PREFIX . "_album_images SET image_file='$new_filename' WHERE id='$image[id]'");
        if (move_uploaded_file($_FILES['userfile' . $x]['tmp_name'], "../gallery/main/" . $new_filename)) {
          chmod("../gallery/main/" . $new_filename, 0777);
          $message .= $filename . " was uploaded successfully!<br />\n";
        } else  $message .= $filename . " could not be saved to server! Check to ensure proper permissions on upload directory.<br />\n";
      } else $message .= $filename . " was not uploaded! File may excede maximum server upload limit or you may have timed out due to a slow internet connection.<br />";
    } else $message .= $filename . " is not a .jpg or .jpeg, can not process!<br />";
    $db->close();
    
    // call to make the resized and thumb images
    MakeThumb($image[id]);
    MakeResized($image[id]);
  }
  
  // reset upload needs
  $uploadNeed = 0;
  $_POST['uploadNeed'] = 0;
}



////////////////////////////////////////////////////////////////
// function ChangeAlbumName()
// changes the albums name
////////////////////////////////////////////////////////////////
function ChangeAlbumName(){
  global $message;
  $db = new DB();
  $albumId = $_POST['albumId'];
  $album_name = $_POST['album_name'];
  
  // fix bad names
  $album_name = STR_REPLACE("'","",$album_name);
  $album_name = STR_REPLACE("\"","",$album_name);
  if($db->query("UPDATE " . DB_PREFIX . "_albums SET title='$album_name' WHERE id='$album_id'")) {
    $message .= "Album name updated with new mane " . $album_name  .". ";
  } else $message .= "Album name NOT updated with new mane " . $album_name  . "! ";
  $db->close();
}



////////////////////////////////////////////////////////////////
// function updateImages()
// updates comments
////////////////////////////////////////////////////////////////
function UpdateImage(){
  global $message;
  $imageCount = $_POST['imageCount'];
  
  // update all images in album
  for ($x = 0; $x < $imageCount; $x++) {
    if ($_POST['deleteId' . $x]) {
      $deleteId = $_POST['deleteId' . $x];
      DeleteImage($deleteId);
      $deleteId = 0;
    } else {
      $id = $_POST['id' . $x];
      $imageText = $_POST['imageText' . $x];
      $imageText = STR_REPLACE("'", "&#39;", $imageText);
      $imageText = STR_REPLACE("\"", "&#39;", $imageText);
      $db = new DB();
      $db->query("UPDATE " . DB_PREFIX . "_album_images SET text='$imageText' WHERE id='$id'");
      $db->close();
      
      // if regenerate thumb checked run 'em
      if ($_POST['newThumb' . $x]) {
        MakeThumb($id);
        MakeResized($id);
      }
    }
  }
  $message .= "Album updated. ";
}

// process page
$mode = $_POST['mode'];
if($mode == "Upload") UploadImage();
if($mode == "Change") ChangeAlbumName();
if($mode == "Update") UpdateImage();

// load database
$db = new DB();
if($_POST['albumId']) $albumId = $_POST['albumId'];
$db->query("SELECT * FROM ".DB_PREFIX."_albums WHERE id='$albumId'"); // albumId loaded from URL
$album = $db->next_record();
$db->close();

// start html
echo "\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Frameset//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-f.dtd\">";
echo "\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n<head>";
echo "\n<title>" . $album[title] . " Album Menu</title>";
echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html charset=iso-8859-1\" />";
echo "\n<link rel=\"stylesheet\" href=\"../templates/" . $configuration[template] . "/admin.css\" type=\"text/css\" />";
echo "\n</head>\n<body>\n<div>";
echo "\n<h1>" . $album[title] . " Album Menu</h1>";
echo "\n</div>";
if($message != "") echo "<div><b>" . $message . "</b></div>";

// change album name form
echo "\n<div>\n<form name=\"change_album_name\" method=\"post\" action=\"\">";
echo "\nAlbum Title: <input type=\"text\" id=\"album_name\" name=\"album_name\" value=\"" . $album[title] . "\" size=\"50\">";
echo "\n<input type=\"hidden\" name=\"albumId\" value=\"" . $album[id] . "\">";
echo "\n<input type=\"submit\" name=\"mode\" value=\"Change\">";
echo "\n</form>\n</div>";

// update/view form
echo "\n<div>\n<form name='update' method='post' action=''>";
$db = new DB();
$db->query("SELECT * FROM ".DB_PREFIX."_album_images WHERE album_id='$albumId' ORDER BY id");
$total = $db->num_rows();
for ($x=0; $x<$total; $x++) {
  $image = $db->next_record();
  list($imageWidth, $imageHeight) = getimagesize("../gallery/main/$image[image_file]");
  echo "\n<div class=\"invisible\"><a href=\"../gallery/resized/" . $image[image_file] . "\" target=\"_new\"><img src=\"../gallery/thumb/" . $image[image_file] ."\" /></a>";
  echo "\nID: " . $image[id] . "<br />Filename: " . $image[image_file] . "<br />Size: " . $imageWidth . "x" . $imageHeight . "<br />\n";
  echo "\nComments: <input type=\"text\" name=\"imageText" . $x . "\" value=\"" . $image[text] . "\" size=\"50\" />";
  echo "\n<input type=\"hidden\" name=\"id" . $x . "\" value=\"" . $image[id] . "\" /><br />";
  echo "\nRecreate thumbnail: <input type=\"checkbox\" value=\"" . $image[id] . "\" name=\"newThumb" . $x . "\" /> ";
  echo "\n<br />Delete: <input type=\"checkbox\" value=\"" . $image[id] . "\" name=\"deleteId" . $x . "\" /></div>";
}
echo "\n</div>\n";
$db->close();

// total images
echo "\n<div><input type=\"hidden\" name=\"imageCount\" value=\"" . $total . "\" />";
echo "\nUpdate all images: <input type=\"submit\" name=\"mode\" value=\"Update\"></form>\n";
echo "\n<br />Currently there are $total images in this album.</div>";

// upload form
$uploadNeed = $_POST['uploadNeed'];
if($uploadNeed > 0){
  echo "\n<div><form enctype=\"multipart/form-data\" action=\"\" method=\"post\">\n";
  echo "\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"999999999\" />";
  echo "\n<input type=\"hidden\" name=\"albumId\" value=\"" . $albumId . "\" />";
  echo "\n<input type=\"hidden\" name=\"uploadNeed\" value=\"". $uploadNeed . "\" />";
  echo "\n<input type=\"hidden\" name=\"mode\" value=\"Upload\" />Upload jpg, or jpeg files:<br />";
  for($x=0;$x<$uploadNeed;$x++){
    echo "\n<input type=\"file\" name=\"userfile" . $x . "\" id=\"userfile" . $x . "\" /><br />";
  }
  echo "\n<input type=\"submit\" value=\"Upload\" /></form>";
} else {
  echo "\n<div>\n<form name=\"form1\" method=\"post\" action=\"\">";
  echo "\nEnter the number of images you wish to upload (maximum 99): ";
  echo "\n<input width=5 name=\"uploadNeed\" type=\"text\" maxlength=\"2\" /> ";
  echo "\n<input type=\"hidden\" name=\"albumId\" value=\"" . $albumId . "\" /> ";
  echo "\n<input type=\"submit\" name=\"Submit\" value=\"Submit\" /></form></div> ";
}
echo "\n</body>\n</html>";

?>

