<?php

////////////////////////////////////////////////////////////////
// Program:   BareNuked Content Management System for webpage //
//            development                                     //
// Author:    Jay R. Tomten (email: jay@remin8.com |          //
//            web: http://www.remin8.com)                     //
// Address:   204 Truman Street, Knob Noster, MO 65336        //
// Copyright: (C) 2005                                        //
//                                                            //
// This program is free software; you can redistribute it     //
// and/or modify it under the terms of the GNU General Public //
// License as published by the Free Software Foundation;      //
// either version 2 of the License, or (at your option) any   //
// later version.                                             //
////////////////////////////////////////////////////////////////

// get config options
$db = new DB();
$db->query("SELECT * FROM ".DB_PREFIX."_config");
$config = $db->next_record();
$db->close();



////////////////////////////////////////////////////////////////
// fixQuotes()
////////////////////////////////////////////////////////////////
function fixQuotes($string){
    $string2 = STR_REPLACE("&#39;","'",$string);
    $string2 = STR_REPLACE("&#34;","\"",$string2);
    return $string2;
}



// set page variables
$name = fixQuotes($site[name]);
$keywords = fixQuotes($site[keywords]);
$description = fixQuotes($site[description]);
$lasttitle = fixQuotes($lastPage[title]);
$resume = fixQuotes($lastPage[resume]);
$title = fixQuotes($page[title]); 
$content = fixQuotes($page[content]);

// start html
echo "\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
echo "\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n<head>\n<title>" . $name . "</title>";
echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />";
echo "\n<meta name=\"keywords\" content=\"" . $keywords . "\" />";
echo "\n<meta name=\"description\" content=\"" . $description . "\" />";
echo "\n<link href=\"templates/default/default.css\"  rel=\"stylesheet\" type=\"text/css\" />";
echo "\n</head>";
echo "\n\n<body>";
echo "\n\n<div class=\"divHeader\">" . $name . "</div>";

// menu
echo "\n\n<div class=\"divMenu\">\n<h4>Menu</h4>";
showMenuTree($page[id], "\n<a class=\"small\" href=||link||>||prefix||||title||</a><br/>" , "- " , "&nbsp;&nbsp;- " , "&nbsp;&nbsp;&nbsp;&nbsp;- ");
echo "\n<h4>News</h4>";
news( $site[news] ,"\n- <a class=\"small\" href=\"||link||\">||title||</a><br/>");
echo "\n- <a class=\"small\" href=\"index.php?allnews=1\">View All News!</a>";
echo "\n<h4>Admin</h4>\n- <a class=\"small\" href=\"admin/index.php\">Logon</a><br/>\n- <a class=\"small\" href=\"admin/
index.php?editid=" . $page[id] . "\" target=\"_top\">Edit Page</a>";
echo "\n<h4>Site Info</h4>\n<div class=\"small\">Site rendered by <a href=\"http://www.remin8.com/\">BareNuked</a>, an open source personal homepage content management system. ";
echo "<a href=\"http://jigsaw.w3.org/css-validator/\">Valid CSS</a> | <a href=\"http://validator.w3.org/check?uri=referer\">Valid XHTML</a></div></div>";

// all news
if ($allnews){ 
    // path 
	echo "\n\n<div class=\"divPath\">\n";
	path($page[id], "\n / <a class=big href=\"||link||\">||title||</a>"); 
	echo "\n / <a class=\"big\" href=\"index.php?allnews=1\">All News</a></div>\n";
    // all news
	echo "\n\n<div class=\"divMain\">\n";
    echo "\n\n<div class=\"divContent\">";
	echo "\n<div>\n<h2>All News</h2>\n<ul>";
	showAllNews("<li><a href=\"||link||\"> ||title|| </a> - ||date||</li>\n");
	echo "</ul>\n</div>";
	// search
	echo "\n\n<div class=\"themeSearch\">\n";
	include "includes/search.php";
	echo "\n</div>\n";

// search
} else if ($search) { 
    // path 
	echo "\n\n<div class=\"divPath\">\n";
	path($page[id], "\n / <a class=\"big\" href=\"||link||\">||title||</a>"); 
	echo "\n / <a href=\"\">Search Results</a></div>\n";
    // search results
	echo "\n\n<div class=\"divMain\">\n";
    echo "\n\n<div class=\"divContent\">";
	include "includes/search.php";
    echo "</ul>\n";
	// search
	echo "\n\n<div class=\"themeSearch\">\n";
	echo "\nPlease go back to search again...</div>\n</div>";

// default
} else {
    // path
	echo "\n\n<div class=\"divPath\">\n";
	path($page[id], " / <a class=\"big\" href=\"||link||\">||title||</a>"); 
	echo "\n</div>";
    // page content
	echo "\n\n<div class=\"divMain\">\n";
    echo "\n\n<div class=\"divContent\">";
	echo "\n\n\n<div><h1>" . $title . "</h1></div>\n<div class=\"small\">Posted on " . $page[postDate] . " ";
	if ($page[lastUpDate] != $page[postDate]) echo "| Last Updated on " . $page[lastUpDate] . "";
	echo "\n</div><div class=\"content\">\n" . $content . "\n</div>\n";
	// top news
	if ($page[id]==1) {
		echo "\n\n<div class=\"themeTopNews\">\n<h1>Top News</h1>";
		topNews( $site[top] ,"<div class=\"themeTopNewsArticle\">\n<a class=\"big\" href=\"||link||\">||title||</a>\n<div class=\"small\">Posted on ||date||</div>\n<div class=\"contnet\">||content||</div>\n<div class=\"small\">\n<a class=\"small\" href=\"||link||\">View/Add Comments</a> | <a class=\"small\" href=\"||edit||\" target=\"_top\">Edit Article</a>\n</div></div>");
		echo "\n</div>";
	}
	// photo album
	include "includes/album.php";
	// search
	echo "\n\n<div class=\"themeSearch\">\n";
	include "includes/search.php";
	echo "\n</div>\n";
	// comments
	if ($page[id]!=1) {
		echo "\n<div class=\"themeComments\">\n";
		include "includes/comments.php";
		echo "\n</div>";
	}
}
echo "\n</div></div>\n\n</body>\n\n</html>";

?>

